﻿/// <reference path="http://localhost/ext-2.2/vswd-ext_2.2.js" />

Ext.BLANK_IMAGE_URL = '/ext-2.2/resources/images/default/s.gif';

// 全局缓存名称和资源文件名称
var STORE_NAME = 'GearStudy';
var MANIFEST_FILENAME = 'manifest.txt';
// 定义全局对localserver和ManagedStore的引用
var localServer;
var store;

Ext.onReady(function() {
	// 检查是否已经安装Gears
	if (!window.google || !google.gears) {
		textOut('Note: You must install Gears first.');
		return;
	}
	// 创建localserver和ManagedStore
	localServer = google.gears.factory.create("beta.localserver");
	store = localServer.createManagedStore(STORE_NAME);
	// ManagedStore更新出错时的回调函数，当应用程序离线或者manifest文件出错时，
	// 显示一个错误信息窗口
	store.onerror = function(error) {
		Ext.MessageBox.show({
			title: 'ERROR',
			msg: error.message,
			icon: Ext.MessageBox.ERROR,
			buttons: Ext.MessageBox.OK
		});
	}
	// 定义一个对进度窗口的引用变量，
	var ub;
	// ManagedStore报告进度的回调函数，下载manifest文件中定义的url时调用，
	// 显示一个进度窗口，并根据下载的进度更新进度条。
	store.onprogress = function(details) {
		if (!ub) {
			ub = Ext.MessageBox.progress('Alert', 'Loading offline manifest files ...', '0.00%');
		}
		var val = details.filesComplete / details.filesTotal;
		ub.updateProgress(val, (val * 100).toFixed(0).toString() + '%');
	};
	// ManagedStore完成下载时的回调函数，这个函数可能在两种情况下被调用，
	//   1. 调用checkUpdate函数手工更新；
	//   2. ManagedStore自动检查更新。
	store.oncomplete = function(details) {
		if (ub) {
			ub.hide();
			ub = null;
		}
		if (!Ext.isEmpty(details.newVersion)) {
			textOut('Local manifest version is ' + details.newVersion + ' now !');
		}
	};
	// 输出当前的Gears缓存信息
	var msg;
	if (Ext.isEmpty(store.currentVersion, false)) {
		msg = 'No local manifest find' + ' now !';
	}
	else {
		msg = 'Local manifest version is ' + store.currentVersion + ' now !';
	}
	textOut(msg);
	// 手工更新Gears缓存
	Ext.fly('offlineBtn').on('click', function() {
		store.manifestUrl = MANIFEST_FILENAME;
		store.checkForUpdate();
	});
	// 手工删除Gears缓存
	Ext.fly('onlineBtn').on('click', function() {
		localServer.removeManagedStore(STORE_NAME);
		textOut(
			"Done. The local store has been removed." +
			"You will now see online versions of the documents."
		);
	});
	
	Ext.fly('showWindow').on('click', function() {
		if (!window.win) {
			win = new Ext.Window({ width: 320, height: 240, title: 'Hello,world', closeAction: 'hide' });
		}
		win.show('showWindow');
	});
});

// Utility function to output some status text.

function textOut(s) {

	Ext.fly('msg').update(s);

}